from typing import Protocol
from uuid import UUID

from fastfood_two.domain.menu.menu_entity import Menu


class MenuGateway(Protocol):
    async def get_menu_by_id(self, id: UUID) -> Menu | None:
        raise NotImplementedError

    async def insert_menu(self, menu: Menu) -> Menu:
        raise NotImplementedError

    async def get_all_menus(self) -> list[Menu]:
        raise NotImplementedError

    async def update_menu(self, updated_menu: Menu) -> Menu | None:
        raise NotImplementedError

    async def delete_menu(self, id: UUID) -> None:
        raise NotImplementedError
