from sqlalchemy import ForeignKey
from sqlalchemy.orm import Mapped, mapped_column, relationship

from .base import Base
from .common_attrs import str_25, uuidpk


class SQLAMenu(Base):
    __tablename__ = "menus"

    id: Mapped[uuidpk]
    title: Mapped[str_25]
    description: Mapped[str | None]

    parent: Mapped[uuidpk | None] = mapped_column(ForeignKey("menus.id", ondelete="CASCADE"), nullable=True)

    submenus: Mapped[list["SQLAMenu"]] = relationship(
        "SQLAMenu",
        backref="menus",
        lazy="selectin",
        cascade="all, delete",
    )
